﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WoodPelletShop
{
    public class Order
    {
        private static int nextId = 1;
        public int Id { get; set; } //Ordernumber
        public WoodPellet WoodPellet { get; set; }
        public Customer Customer { get; set; }
        public int Amount { get; set; }
        public DateOnly OrderDate { get; set; }
        public DateOnly DeleveryDate { get; set; }
        public Address DeleveryAddress { get; set; }

        public Order(WoodPellet woodPellet, Customer customer, int amount, DateOnly orderDate, DateOnly deleveryDate, Address deleveryAddress)
        {
            Id = nextId++;
            WoodPellet = woodPellet;
            Customer = customer;
            Amount = amount;
            OrderDate = orderDate;
            DeleveryDate = deleveryDate;
            DeleveryAddress = deleveryAddress;
        }

        public Order()
        {
            Id = nextId++;
        }

        public override string ToString()
        {
            return $"{{{nameof(Id)}={Id.ToString()}, {nameof(WoodPellet)}={WoodPellet}, {nameof(Customer)}={Customer}, {nameof(Amount)}={Amount.ToString()}, {nameof(OrderDate)}={OrderDate.ToString()}, {nameof(DeleveryDate)}={DeleveryDate.ToString()}, {nameof(DeleveryAddress)}={DeleveryAddress}}}";
        }
    }
}
